#!/usr/bin/perl -w

use strict;
use DBI;

my ($db,$user,$pass);
my ($sql,$sth,$ref,$ref2);
my $retval = 0;
my $retstr = "";
my @nagiosResult= ('OK','WARNING','CRITICAL','UNKNOWN');

# Validate script parameters: SERVER_NAME
if (scalar(@ARGV) != 1) {
	print "UNKNOWN: Usage: $0 SERVER_NAME\n";
	exit 3;
}

# assign names to the arguments from the command-line
my $host = $ARGV[0];

# Set access parameters for remote snmptt database
$db  = "snmptt";		# Database name
$user = "nagios";	# MySQL User ID
$pass = "nagios123";	# MySQL Password

# Open the database
my $dbh = DBI->connect("DBI:mysql:database=$db;host=localhost;port=3306",$user,$pass,{'RaiseError' => 1});

# Get the number of traps for the specified host name
$sql = "select severity from snmptt where hostname='$host' and acknowledged<>1";
$sth = $dbh->prepare($sql);
$sth->execute;
if ($sth->rows == 0){
	$retstr = "No new traps recieved.";
	$retval = 0;
}else{
	$ref = $sth->fetchall_hashref('severity');
	if ( exists $ref->{'CRITICAL'}){
		$retstr = "One or more new CRITICAL trap(s) recieved.";
		$retval = 2;
	}else{
		$retstr = "One or more new trap(s) recieved.";	
		$retval = 1;
	}

}
$sth->finish;
$dbh->disconnect;

print $nagiosResult[$retval] . ": " . $retstr . "\n";
exit $retval;
